{ pkgs, lib, ... }:
{
  systemd.services."nextcloud-setup".requires = [ "postgresql.service" ];
  systemd.services."nextcloud-setup".after = [ "postgresql.service" ];

  environment.etc."nextcloud-admin-pass".text = "test123";
  services.nextcloud = {
    enable = true;
    package = pkgs.nextcloud28;
    hostName = "nc.hoyer.xyz";
    https = true;
    configureRedis = true;
    extraOptions = {
      mail_smtpmode = "sendmail";
      mail_sendmailmode = "pipe";
    };
    phpOptions = {
      upload_max_filesize = lib.mkForce "1G";
      post_max_size = lib.mkForce "1G";
      "opcache.interned_strings_buffer" = "16";
    };
    config.adminpassFile = "/etc/nextcloud-admin-pass";
    config.defaultPhoneRegion = "DE";
    config.dbtype = "pgsql";
    config.dbname = "nextcloud";
    config.dbhost = "/run/postgresql";
    config.dbuser = "nextcloud";
  };
}
